ACT_HOMINGATTACK = allocate_mario_action(ACT_FLAG_MOVING    | ACT_FLAG_ATTACKING    |    ACT_FLAG_INVULNERABLE )
ACT_TELEPORTA =  allocate_mario_action( ACT_FLAG_INTANGIBLE | ACT_FLAG_MOVING )


local function act_homing_attack(m)
  common_air_action_step(m, ACT_JUMP_LAND, 0x6F, AIR_STEP_NONE)
  ATTACK_HANDLER_KNOCKBACK = 90
  local ObjectValue = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvGoomba)
  local obj = nil
  local dist = 2000
  local goom = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvGoomba)
  if goom ~= nil then
    local goomdist = math.abs(goom.oPosX - m.pos.x) + math.abs(goom.oPosY - m.pos.y) + math.abs(goom.oPosZ - m.pos.z)
    if goomdist < dist then
      obj = goom
      dist = goomdist
    end
  end
  local coin = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvYellowCoin)
  if coin ~= nil then
    local coindist = math.abs(coin.oPosX - m.pos.x) + math.abs(coin.oPosY - m.pos.y) + math.abs(coin.oPosZ - m.pos.z)
    if coindist < dist then
      obj = coin
      dist = coindist
    end
  end
  local bomb = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvBobomb)
  if bomb ~= nil then
    local bombdist = math.abs(bomb.oPosX - m.pos.x) + math.abs(bomb.oPosY - m.pos.y) + math.abs(bomb.oPosZ - m.pos.z)
    if bombdist < dist then
      obj = bomb
      dist = bombdist
    end
  end
  local chuck = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvChuckya)
  if chuck ~= nil then
    local chuckdist = math.abs(chuck.oPosX - m.pos.x) + math.abs(chuck.oPosY - m.pos.y) + math.abs(chuck.oPosZ - m.pos.z)
    if chuckdist < dist then
      obj = chuck
      dist = chuckdist
    end
  end
  local redcoin = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvRedCoin)
  if redcoin ~= nil then
    local rcoindist = math.abs(redcoin.oPosX - m.pos.x) + math.abs(redcoin.oPosY - m.pos.y) + math.abs(redcoin.oPosZ - m.pos.z)
    if rcoindist < dist then
      obj = redcoin
      dist = rcoindist
    end
  end
  local blucoin = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvBlueCoinJumping)
  if blucoin ~= nil then
    local bcoindist = math.abs(blucoin.oPosX - m.pos.x) + math.abs(blucoin.oPosY - m.pos.y) + math.abs(blucoin.oPosZ - m.pos.z)
    if bcoindist < dist then
      obj = blucoin
      dist = bcoindist
    end
  end
  local tree = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvSnufit)
  if tree ~= nil then
    local treedist = math.abs(tree.oPosX - m.pos.x) + math.abs(tree.oPosY - m.pos.y) + math.abs(tree.oPosZ - m.pos.z)
    if treedist < dist then
      obj = tree
      dist = treedist
    end
  end
  local piano = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvMadPiano)
  if piano ~= nil then
    local pianodist = math.abs(piano.oPosX - m.pos.x) + math.abs(piano.oPosY - m.pos.y) + math.abs(piano.oPosZ - m.pos.z)
    if pianodist < dist then
      obj = piano
      dist = pianodist
    end
  end
  local klepto = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvKlepto)
  if klepto ~= nil then
    local kleptodist = math.abs(klepto.oPosX - m.pos.x) + math.abs(klepto.oPosY - m.pos.y) + math.abs(klepto.oPosZ - m.pos.z)
    if kleptodist < dist then
      obj = klepto
      dist = kleptodist
    end
  end
  local pole = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvPoleGrabbing)
  if pole ~= nil then
    local poledist = math.abs(pole.oPosX - m.pos.x) + math.abs(pole.oPosY - m.pos.y) + math.abs(pole.oPosZ - m.pos.z)
    if poledist < dist then
      obj = pole
      dist = poledist
    end
  end
  local bb = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvBalconyBigBoo)
  if bb ~= nil then
    local bbdist = math.abs(bb.oPosX - m.pos.x) + math.abs(bb.oPosY - m.pos.y) + math.abs(bb.oPosZ - m.pos.z)
    if bbdist < dist then
      obj = bb
      dist = bbdist
    end
  end
  local canon = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvBobombBuddyOpensCannon)
  if canon ~= nil then
    local canondist = math.abs(canon.oPosX - m.pos.x) + math.abs(canon.oPosY - m.pos.y) + math.abs(canon.oPosZ - m.pos.z)
    if canondist < dist then
      obj = canon
      dist = canondist
    end
  end
  local bun = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvMips)
  if bun ~= nil then
    local bundist = math.abs(bun.oPosX - m.pos.x) + math.abs(bun.oPosY - m.pos.y) + math.abs(bun.oPosZ - m.pos.z)
    if bundist < dist then
      obj = bun
      dist = bundist
    end
  end
  local pen = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvPenguinBaby)
  if pen ~= nil then
    local pendist = math.abs(pen.oPosX - m.pos.x) + math.abs(pen.oPosY - m.pos.y) + math.abs(pen.oPosZ - m.pos.z)
    if pendist < dist then
      obj = bun
      dist = pendist
    end
  end
  local mole = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvMontyMole)
  if mole ~= nil then
    local moledist = math.abs(mole.oPosX - m.pos.x) + math.abs(mole.oPosY - m.pos.y) + math.abs(mole.oPosZ - m.pos.z)
    if moledist < dist then
      obj = mole
      dist = moledist
    end
  end
  local dolla = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvMoneybag)
  if dolla ~= nil then
    local dolladist = math.abs(dolla.oPosX - m.pos.x) + math.abs(dolla.oPosY - m.pos.y) + math.abs(dolla.oPosZ - m.pos.z)
    if dolladist < dist then
      obj = dolla
      dist = dolladist
    end
  end
  local bully = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvSmallBully)
  if bully ~= nil then
    local bullydist = math.abs(bully.oPosX - m.pos.x) + math.abs(bully.oPosY - m.pos.y) + math.abs(bully.oPosZ - m.pos.z)
    if bullydist < dist then
      obj = bully
      dist = bullydist
    end
  end
  local bbully = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvBigBully)
  if bbully ~= nil then
    local bbullydist = math.abs(bbully.oPosX - m.pos.x) + math.abs(bbully.oPosY - m.pos.y) + math.abs(bbully.oPosZ - m.pos.z)
    if bbullydist < dist then
      obj = bbully
      dist = bbullydist
    end
  end
  local pokey = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvPokey)
  if pokey ~= nil then
    local pokeydist = math.abs(pokey.oPosX - m.pos.x) + math.abs(pokey.oPosY - m.pos.y) + math.abs(pokey.oPosZ - m.pos.z)
    if pokeydist < dist then
      obj = pokey
      dist = pokeydist
    end
  end
  local ic = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvBigChillBully)
  if ic ~= nil then
    local icdist = math.abs(ic.oPosX - m.pos.x) + math.abs(ic.oPosY - m.pos.y) + math.abs(ic.oPosZ - m.pos.z)
    if icdist < dist then
      obj = ic
      dist = icdist
    end
  end
  local fly = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvFlyGuy)
  if fly ~= nil then
    local flydist = math.abs(fly.oPosX - m.pos.x) + math.abs(fly.oPosY - m.pos.y) + math.abs(fly.oPosZ - m.pos.z)
    if flydist < dist then
      obj = fly
      dist = flydist
    end
  end
    local kg = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvKingBobomb)
  if kg ~= nil then
    local kgdist = math.abs(kg.oPosX - m.pos.x) + math.abs(kg.oPosY - m.pos.y) + math.abs(kg.oPosZ - m.pos.z)
    if kgdist < dist then
      obj = kg
      dist = kgdist
    end
  end
  local bow = obj_get_nearest_object_with_behavior_id(m.marioObj, id_bhvScuttlebug)
  if bow ~= nil then
    local bowdist = math.abs(bow.oPosX - m.pos.x) + math.abs(bow.oPosY - m.pos.y) + math.abs(bow.oPosZ - m.pos.z)
    if bowdist < dist then
      obj = bow
      dist = bowdist
    end
  end 
if obj ~= nil
then

      m.pos.x = obj.oPosX - 50
       m.pos.y = obj.oPosY -50
      m.pos.z = obj.oPosZ +80
play_character_sound(m, CHAR_SOUND_HELLO)
else
  if m.vel.y < -15 then
m.forwardVel = 70
end
end
end




edgyhedgy = _G.charSelect.character_get_number_from_string("Shadow The Hedgehog")


local function mario_update(m)
      if edgyhedgy == _G.charSelect.character_get_current_number() then
          gPlayerSyncTable[m.playerIndex].chaospower = true
      else
          gPlayerSyncTable[m.playerIndex].chaospower = false
  

      end

      if (m.controller.buttonPressed & Y_BUTTON) ~= 0 and gPlayerSyncTable[m.playerIndex].chaospower and (m.action & ACT_FLAG_SWIMMING) ==  0 then
 
        set_mario_action(m, ACT_HOMINGATTACK, 0)
      
    end
  end


hook_mario_action (ACT_HOMINGATTACK, act_homing_attack)
hook_event(HOOK_MARIO_UPDATE, mario_update)